/* Generic load for hardware simulator models.
   Copyright (C) 1997 Free Software Foundation, Inc.
   Contributed by Cygnus Support.

This file is part of GDB, the GNU debugger.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#include "sim-main.h"
#include "bfd.h"
#include "sim-utils.h"
#include "sim-assert.h"

/* add T.Tazaki 2002/10/03 >>>*/

/***************************************************
 * c33Common Target Information define and struct *
****************************************************/
#define CORE_ADDR   unsigned long
#include "../../gdb/c33common.h"

/* >>>>> change iruma m.takeishi '03.02.27 */
/*
static struct c33_target_info copy_c33TargetInfo; // target information //
*/
static struct c33_target_info *p_c33TargetInfo;   /* target information */
/* <<<<< change iruma m.takeishi '03.02.27 */
static int iMapSetted = 0;

/***************************************************
 * c33Common Target Information struct Get *
****************************************************/
/* >>>>> change iruma m.takeishi '03.02.27 */
/*
void
sim_map_set4( struct c33_target_info org_c33TargetInfo )
{
*/
void
sim_map_set4( struct c33_target_info *org_c33TargetInfo )
{
    iMapSetted = 1;

    //copy_c33TargetInfo = org_c33TargetInfo;
    p_c33TargetInfo = org_c33TargetInfo;
}
/* <<<<< change iruma m.takeishi '03.02.27 */

/* add T.Tazaki 2002/10/03 <<<*/

/* Generic implementation of sim_load that works with simulators
   modeling a hardware platform. */

SIM_RC
sim_load (sd, prog_name, prog_bfd, from_tty)
     SIM_DESC sd;
     char *prog_name;
     struct _bfd *prog_bfd;
     int from_tty;
{
  bfd *result_bfd;
    char szAddr_wk[10];      /* add T.Tazaki 2002/10/03 */
    char *myaddr_wk;         /* add T.Tazaki 2002/10/03 */
    char szAddr_wk2[10];     /* add T.Tazaki 2002/10/03 */
    char *myaddr_wk2;        /* add T.Tazaki 2002/10/03 */
    int  i_adv = 1;          /* add T.Tazaki 2002/10/03 */

    myaddr_wk  = szAddr_wk;  /* add T.Tazaki 2002/10/03 */
    myaddr_wk2 = szAddr_wk2; /* add T.Tazaki 2002/10/03 */

  SIM_ASSERT (STATE_MAGIC (sd) == SIM_MAGIC_NUMBER);
  if (sim_analyze_program (sd, prog_name, prog_bfd) != SIM_RC_OK)
    return SIM_RC_FAIL;
  SIM_ASSERT (STATE_PROG_BFD (sd) != NULL);

  /* NOTE: For historical reasons, older hardware simulators
     incorrectly write the program sections at LMA interpreted as a
     virtual address.  This is still accommodated for backward
     compatibility reasons. */

/* add T.Tazaki 2002/10/03 >>>*/
    /* TTBR save */

    /* >>>>> change iruma m.takeishi '03.02.27 */
    /*
    if( ( copy_c33TargetInfo.pMapInfo == NULL ) ||  // Standard Macro ? //
        ( copy_c33TargetInfo.pMapInfo != NULL && copy_c33TargetInfo.ucAdvanced != C33_PRODUCT_ADV ) )
    {
    */
    if( ( p_c33TargetInfo->pMapInfo == NULL ) ||  /* Standard Macro ? */
        ( p_c33TargetInfo->pMapInfo != NULL && p_c33TargetInfo->ucAdvanced != C33_PRODUCT_ADV ) )
    {
    /* <<<<< change iruma m.takeishi '03.02.27 */
        i_adv = 0;
        
        sim_read (sd, 0x4812d, (unsigned char *)myaddr_wk, 1);          /* Get 0x4812d */
        sim_read (sd, C33_ADDR_TTBR, (unsigned char *)myaddr_wk2, 4);   /* Get 0x48134 */
    }

/* add T.Tazaki 2002/10/03 <<<*/

  result_bfd = sim_load_file (sd, STATE_MY_NAME (sd),
                  STATE_CALLBACK (sd),
                  prog_name,
                  STATE_PROG_BFD (sd),
                  STATE_OPEN_KIND (sd) == SIM_OPEN_DEBUG,
/* Modify 2002/07/15 T.Tazaki      STATE_LOAD_AT_LMA_P (sd), */
                  1,    /* Modify 2002/07/15 T.Tazaki */
                  sim_write);
  if (result_bfd == NULL)
    {
      bfd_close (STATE_PROG_BFD (sd));
      STATE_PROG_BFD (sd) = NULL;
      return SIM_RC_FAIL;
    }

/* add T.Tazaki 2002/10/03 >>>*/
    if( i_adv == 0 )    /* Standard macro ? */
    {
        if( *myaddr_wk != 0x59 )    /* TTBR write disable ? */
        {
            /* TTBR reload */
            sim_write (sd, C33_ADDR_TTBR, myaddr_wk2, 4);
        }
    }
/* add T.Tazaki 2002/10/03 <<<*/


  return SIM_RC_OK;
}
