/*
 * Created on 2004/08/17
 * Modified on 2006/11/27 by D.Fujimoto added isInvisible(), setInvisible()
 */
package jp.co.epson.ide.eclipse.gnu33.build;

import java.util.List;

/**
 * Interface for a build option.
 * @author D.Fujimoto
 */
public interface IBuildOption {

	/**
	 * Constants for type
	 */
	public static final int TYPE_STRING = 1;
	public static final int TYPE_BOOLEAN = 2;
	public static final int TYPE_LIST = 3;
	public static final int TYPE_ENUM = 4;
	public static final int TYPE_STRING_MULTI = 5;
	
	// delimiter for list options
	public static final String LIST_DELIMITER = ";"; //$NON-NLS-1$
	
	
	public String getId();
	public IBuildTool getTool();
	public IBuildCategory getCategory();
	public boolean isNeedArgs();
	public String getCommand();
	public String getLabel();
	public void setLabel(String label);
	public int getType();
	public String getCommandFalse();
	public List getCommandList();
	public int getBrowseType();
	public boolean isInvisible();
	public void setInvisible(boolean flag);

	public boolean getBooleanValue();
	public void setBooleanValue(boolean value);
	public String getStringValue();
	public void setStringValue(String value);
	public String[] getListValue();
	public void setListValue(String[] values);
	public String[] getEnumOptions();
	public String getEnumCommand();
	public String getEnumCommand(String selectedValue);
	public int getEnumValue();
	public void setEnumValue(int value);
	
}
