/*
 * 쐬: 2006/03/24
 *
 */
package jp.co.epson.ide.eclipse.gnu33.build;

/**
 * Interface for an environment setting.
 * 
 * @author D.Fujimoto
 * @since 1.3.0
 *
 */
public interface IEnvVar extends Comparable {

	/**
	 * Returns the name of the variable
	 * @return name
	 */
	public String getName();
	
	/**
	 * Returns the value of the variable
	 * @return value
	 */
	public String getValue();
	
	/**
	 * Returns whether if this variable is in use.
	 * @return	flag true if in use, false otherwise
	 */
	public boolean isInUse();
	
	/**
	 * Returns whether if this variable is a reserved one.
	 * @return flag true if reserved, false otherwise
	 */
	public boolean isReserved();
	
}
