/*
 * 쐬: 2005/09/08
 *
 */
package gnu33dll;


/**
 * Exception for OSMonitorConnection.
 * @author D.Fujimoto
 *
 */
public class OSMonitorConnectionException extends Exception {


	/**
	 * @since 1.1.0
	 */
	private static final long serialVersionUID = 1L;
	
	/**
	 * Flag for error code. See the status codes defined in OSMonitorConnection.
	 */
	private int causeFlag;
	
	public OSMonitorConnectionException(int causeFlag) {
		this.causeFlag = causeFlag;
	}
	
	public OSMonitorConnectionException(String message) {
		super(message);
	}
	
	/**
	 * Access to the cause flag.
	 * @return cause flag
	 */
	public int getCauseFlag() {
		return causeFlag;
	}
	
	
	public void printStackTrace() {
		super.printStackTrace();
		System.err.println("Cause:" + getCauseFlag());
	}
}
