/*
 * 쐬: 2005/12/07
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.command;

import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.ToppersMonitorController;

/**
 * Factory class for creating a MonitorCommand.
 * 
 * @author D.Fujimoto
 *
 */
public class MonitorCommandFactory {

	// XXX:the types are actually identical to the tab index...
	public static final int MNG	= 0;
	public static final int TASK = 1;
	public static final int RDYQ = 2;
	public static final int CYC 	= 3;
	public static final int MBX 	= 4;
	public static final int SEM 	= 5;
	public static final int FLG 	= 6;
	public static final int DTQ 	= 7;
	public static final int MPF 	= 8;
	public static final int INT 	= 9;
	public static final int EXCP = 10;
	public static final int ALL = 100;
	
	/**
	 * Creates a monitor command given the type parameter
	 * @param type		Command type to create(identical to the tab index)
	 * @param controller	Controller class
	 * @return
	 */
	public static MonitorCommand createCommand(int type, ToppersMonitorController controller) {
	
		switch (type) {
			
			case MNG :
			case TASK :
				return new GetBaseCommand(controller);
			case RDYQ :
				return new GetRdyQCommand(controller);
			case CYC :
				return new GetCycCommand(controller);
			case MBX :
				return new GetMbxCommand(controller);
			case SEM :
				return new GetSemCommand(controller);
			case FLG :
				return new GetFlagCommand(controller);
			case DTQ :
				return new GetDataQCommand(controller);
			case MPF :
				return new GetFixedMemCommand(controller);
			case INT :
				return new GetIntCommand(controller);
			case EXCP :	
				return new GetExcpCommand(controller);
			case ALL :
				return new GetAllCommand(controller);
		}
		
		return null;
		
	}
	
}
