/*
 * 쐬: 2005/06/14
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input;

import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.CyclicHandlerData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.DataQueueData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.EventFlagData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.ExceptionHandlerData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.FixedMemoryPoolData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.InterruptHandlerData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.MailBoxData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.ReadyQueueData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.SemaphoreData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.TaskData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.TaskManagementData;

/**
 * Interface for the input for Toppers/JSP OS.
 * 
 * @author D.Fujimoto
 *
 */
public interface IToppersMonitorInput {

	TaskManagementData getTaskManagementData();
	ReadyQueueData[] getReadyQueueData();
	TaskData[] getTaskData();
	CyclicHandlerData[] getCyclicHandlerData();
	MailBoxData[] getMailBoxData();
	SemaphoreData[] getSemaphoreData();
	EventFlagData[] getEventFlagData();
	DataQueueData[] getDataQueueData();
	FixedMemoryPoolData[] getFixedMemoryPoolData();
	InterruptHandlerData[] getInterruptHandlerData();
	ExceptionHandlerData[] getExceptionHandlerData();
	
	/**
	 * Returns the minimum priority value.
	 * @return	priority
	 */
	int getMinPriority();
	
	/**
	 * Returns the address of the current running task.
	 * @return address
	 */
	long getRunTaskAddress();
	
	/**
	 * Returns the task names stored in TaskData[]
	 * @return task names 
	 */
	String[] getTaskNames();
}
