/*
 * 쐬: 2005/10/05
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data;

/**
 * Interface for model data that has a Queue.
 * @author D.Fujimoto
 *
 */
public interface IQueue {

	/**
	 * Default type to pass to getNextQueue() and getPrevQueue().
	 */
	public static int DEFAULT_TYPE = -1;
	
	
	
	/**
	 * Returns the next queue address.
	 * @param type	 Used to swtich what queue values to return.
	 * @return	next address.
	 */
	public long getNextQueue(int type);
	
	/**
	 * Returns the previous queue address.
	 * @param	type	Used to swtich what queue values to return.
	 * @return	previous address.
	 */
	public long getPrevQueue(int type);
	
	/**
	 * Sets the indices to TaskData[] which is a queue list.
	 * @param indices
	 * @param type		Used to swtich what queue values to set.
	 */
	public void setQueueIndices(int[] indices, int type);
	
	/**
	 * Retruns the indices to TaskData[]. 
	 * @param	type	Used to swtich what queue values to get.
	 * @return indices
	 * 
	 */
	public int[] getQueueIndices(int type);
}
