/*
 * 쐬: 2005/06/15
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content;

import org.eclipse.jface.viewers.IContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.Composite;

/**
 * Monitor view that has a TableViewer as its display. 
 * @author D.Fujimoto
 *
 */
public interface IMonitorViewContent {

	/**
	 * Returns the table name.
	 * Used as the tab title
	 * @return	the table name
	 */
	public String getTableName();
	
	/**
	 * Returns the labels for the columns
	 * @return column labels
	 */
	public String[] getColumnLabels();
	
	/**
	 * Returns the width for the columns
	 * @return column widths
	 */
	public int[] getColumnWidth();
	
	/**
	 * Returns the column count
	 * @return the column count
	 */
	public int getColumnCount();
	
	/**
	 * Creates a TableViewer on the given Composite
	 * @param parent
	 * @return	the TableViewer for this ViewContent
	 */
	public TableViewer createTableViewer(Composite parent);
	
	/**
	 * Access to the TableViewer
	 * @return the TableViewer for this ViewContent
	 */
	public TableViewer getTableViewer();
	
	/**
	 * Access to the ContentProvider
	 * @return the ContentProvider for the TableViewer
	 */
	public IContentProvider getContentProvider();
	
}
